<div id="app-content" [ngClass]="appTheme">
  <header [class]="isDebug?'material-header debug shadow':'material-header shadow'">
    <div class="material-header-row">
      <div class="material-header-title">
        <material-button *ngIf="g.isConfigured"
                         icon id="btnMenu"
                         [disabled]="currPage=='pdfList'"
                         class="material-drawer-button" (trigger)="drawer.toggle()">
          <material-icon icon="menu"></material-icon>
        </material-button>
        <div class="title">
          {{g.title}}
          <span class="betaTitle" *ngIf="g.isBeta">BETA</span>
          <material-button class="localTitle" *ngIf="g.runsLocal" (trigger)="g.isLocal = !g.isLocal">
            <div *ngIf="g.isLocal">Lokal</div>
            <div *ngIf="!g.isLocal">Vorschau</div>
          </material-button>
          <material-button class="localTitle" *ngIf="g.isLocal" (trigger)="g.showBothUnits = !g.showBothUnits">
            <div *ngIf="!g.showBothUnits">{{g.glucMGDL?g.msgUnitMGDL:g.msgUnitMMOL}}</div>
            <div *ngIf="g.showBothUnits">{{g.msgUnitMGDL}}<br/>{{g.msgUnitMMOL}}</div>
          </material-button>
          <div class="versionText">{{g.version}}</div>
          <div class="subtitle" *ngIf="currPage=='impressum'">{{msgImpressum}}</div>
          <div class="subtitle" *ngIf="currPage=='dsgvo'">{{msgDSGVO}}</div>
        </div>
      </div>
      <div [class]="classForView('basePanel')">
        <div *ngIf="g.userList.length == 1" class="userName">{{g.user.display}}</div>
        <div [class]="classForView('userPanel')" *ngIf="g.userList.length > 1">
          <material-dropdown-select label="Benutzer" [buttonText]="g.user.display" popupClass="userSelect" slide="y"
                                    listAutoFocus>
            <material-select-item *ngFor="let item of g.userList; let idx = index"
                                  (trigger)="g.userIdx=idx;reportData=null;g.saveStorage('userIdx','${g.userIdx} - test');getCurrentGluc();"
                                  class="selectItem"
                                  [selected]="idx==g.userIdx">
              <div class="itemTitle">{{item.name.isEmpty?item.apiUrl:item.name}}</div>
              <div class="itemSub">{{item.storageApiUrl}}</div>
            </material-select-item>
          </material-dropdown-select>
        </div>
        <datepicker [period]="g.period" (periodChange)="changePeriod($event)" [isLocal]="g.isLocal"
                    [showInfo]="g.showInfo" [showLabel]="false"></datepicker>
      </div>
      <nav class="material-navigation">
        <material-button *ngIf="g.showCurrentGluc" raised class="currentGluc" (trigger)="getCurrentGluc()">
          <pre *ngIf="!currentGlucVisible" @i18n="message for current glucose if not active">Pausiert</pre>
          <div *ngIf="currentGlucVisible">{{currentGluc}}
            <div time>{{currentGlucTime}}</div>
            <div *ngIf="g.isLocal" debug>{{currentGlucCounter}}</div>
          </div>
          <div arrow *ngIf="currentGlucVisible">
            <div>
              <svg class="arrow" [style.transform]="currentGlucDir" viewBox="0 0 100 100" version="1.1"
                   xmlns="http://www.w3.org/2000/svg">
                <g transform="matrix(0.689535,0,0,0.689535,15.5233,15.5233)">
                  <circle class="circle" cx="50" cy="50" r="37.391"/>
                </g>
                <g transform="matrix(2.13103,0,0,1,-113.103,0.000479201)">
                  <path d="M100,50.002L87.391,59.934L87.395,40.065L100,50.002Z"/>
                </g>
              </svg>
            </div>
            <div diff class="centered">{{currentGlucDiff}}</div>
          </div>
        </material-button>
        <a *ngIf="!g.showCurrentGluc" href="http://www.nightscout.info/" target="_blank">#WeAreNotWaiting</a>
        <material-button icon class="is-local" *ngIf="g.isLocal" (trigger)="g.showInfo=!g.showInfo">
          <material-icon icon="help_outline"></material-icon>
        </material-button>
        <material-fab mini class="debug-trigger" *ngIf="g.canDebug && currPage=='normal'"
                      (trigger)="reportData=null;isDebug=!isDebug;checkPrint();">
          <material-icon icon="bug_report"></material-icon>
        </material-fab>
        <material-button icon class="is-local" *ngIf="g.isLocal && currPage=='normal' && tileParams==null"
                         (trigger)="createThumbs();">
          <material-icon icon="burst_mode"></material-icon>
        </material-button>
      </nav>
    </div>
  </header>
  <material-content class="main">
    <welcome *ngIf="currPage=='welcome'" (closeClicked)="callbackButton"></welcome>
    <settings *ngIf="currPage=='settings'" (settingsresult)="settingsResult"></settings>
    <impressum *ngIf="currPage=='impressum'" (closeClicked)="callbackButton"></impressum>
    <whatsnew *ngIf="currPage=='whatsnew'" (closeClicked)="callbackButton"></whatsnew>
    <dsgvo *ngIf="currPage=='dsgvo'" (closeClicked)="callbackButton"></dsgvo>
    <div class="signintext" *ngIf="currPage=='signin'" @i18n="signin to google">Anmeldung bei Google...</div>
    <div class="centered" *ngIf="currPage=='pdfList' || progressText != null">
      <div [style.display]="currPage=='signin'?'':'none'" @i18n="message for signin to google">
        Verbinde zu Google Drive...
      </div>
      <div *ngIf="currPage=='pdfList'" class="pdfPage">
        <div class="pdfList">
          <form *ngFor="let pdfData of pdfList; let idx=index" [id]="formId(idx)" [target]="g.pdfTarget" method="post"
                [action]="pdfUrl">
            <input name="vfs" type="hidden" value="ja" *ngIf="g.language.code=='ja_JP'"/>
            <input name="filename" type="hidden" value="{{g.pdfDownload?pdfFilename(idx):''}}"/>
            <input name="data" type="hidden" value="{{pdfData.pdf}}"/>
            <material-button class="pdfButton"
                             (trigger)="openPDF(idx)">
              <div class="pdfButtonText">{{idx+1}}</div>
              <material-icon [icon]="pdfData.isPrinted?'done':'description'"></material-icon>
            </material-button>
            <div *ngIf="g.isLocal" class="is-local pdfSizes">
              {{pdfData.pdf.length}}<br/>
              {{g.pdfCreationMaxSize}}
            </div>
          </form>
        </div>
        <material-button *ngIf="!g.hidePdfInfo && !pdfInfoVisible" class="pdfInfo" @i18n="btnPdfInfo"
                         (trigger)="pdfInfoVisible=true">
          Warum werde ich mit mehreren Buttons genervt, statt eine einzelne PDF angezeigt zu kriegen?
        </material-button>
        <div *ngIf="!g.hidePdfInfo && pdfInfoVisible" class="pdfInfoPanel">
          <div @i18n="msgPdfInfo">
            Einige Browser sind nicht in der Lage PDF Dateien anzuzeigen, die eine bestimmte Grösse überschreiten. Da
            das
            von verschiedenen Faktoren abhängt, die sich nicht ohne Weiteres automatisch ermitteln lassen, gibt es die
            Möglichkeit, statt einer grossen PDF Datei, die nicht angezeigt werden kann, mehrere kleinere PDF Dateien
            zu erzeugen, die der Browser anzeigen kann. In den Einstellungen und hier kann diese Grösse festgelegt
            werden. Diese Seite hier wird nur angezeigt, wenn das PDF aufgeteilt werden musste. Wenn nur ein PDF erzeugt
            wurde, dann wird es direkt angezeigt.
          </div>
          <div class="pdfSlider">
            <div @i18n="small">Klein</div>
            <material-slider class="maxsize" [(value)]="g.pdfControlMaxSize" [min]="1" [step]="1"
                             [max]="pdfSliderMax"></material-slider>
            <div *ngIf="g.pdfControlMaxSize < pdfSliderMax" @i18n="big">Gross</div>
            <div *ngIf="g.pdfControlMaxSize >= pdfSliderMax" @i18n="big">Unbegrenzt</div>
          </div>
          <material-button (trigger)="currPage='normal';createPDF()" class="pdfButton">
            <div class="pdfButtonText" @i18n="pdfCreateAgain">PDF erneut erzeugen</div>
          </material-button>
        </div>
      </div>
      <div class="progress" *ngIf="progressText != null">
        <material-progress [activeProgress]="progressValue" [max]="progressMax"
                           [indeterminate]="progressValue>progressMax"></material-progress>
        <div>{{progressText}}</div>
      </div>
    </div>
    <div class="tileparams" *ngIf="tileParams!=null && progressText == null && !g.showAllTileParams">
      <div title>
        {{tileParams.form.display}}
        <div>
          <material-button (trigger)="g.showAllTileParams=!g.showAllTileParams;$event.stopPropagation();">
            <material-icon icon="list"></material-icon>
          </material-button>
          <material-button (trigger)="tileParams.form.extractParams();tileParams=null;$event.stopPropagation();">
            <material-icon icon="close"></material-icon>
          </material-button>
        </div>
      </div>
      <div parampanel>
        <formparams [paramList]="tileParams.form.sortedParams"></formparams>
      </div>
    </div>
    <div class="tileparams" *ngIf="tileParams!=null && progressText == null && g.showAllTileParams">
      <div title>
        Optionen
        <div>
          <material-button (trigger)="g.showAllTileParams=!g.showAllTileParams;$event.stopPropagation();">
            <material-icon icon="description"></material-icon>
          </material-button>
          <material-button (trigger)="extractAllParams();tileParams=null;$event.stopPropagation();">
            <material-icon icon="close"></material-icon>
          </material-button>
        </div>
      </div>
      <div parampanel>
        <template ngFor let-cfg [ngForOf]="g.listConfig">
          <div *ngIf="isFormVisible(cfg.form) && cfg.checked && cfg.form.sortedParams.length > 0">
            <div paramtitle>{{cfg.form.display}}</div>
            <formparams [paramList]="cfg.form.sortedParams"></formparams>
          </div>
        </template>
      </div>
    </div>
    <div [class]="classForView('normal-content')" *ngIf="tileParams==null"
         [style.display]="progressText == null && currPage=='normal'?'':'none'">
      <div class="formlist" *ngIf="g.viewType=='list'">
        <template ngFor let-cfg [ngForOf]="g.listConfig">
          <div *ngIf="isFormVisible(cfg.form)">
            <div class="sortable" id="list-{{cfg.id}}">
              <material-expansionpanel
                (click)="expansionPanelClicked($event,cfg)"
                (open)="expansionPanelOpen($event,cfg)"
                (close)="expansionPanelClose($event,cfg)"
                [class]="expansionClass(cfg)" flat
                name=""
                [disableHeaderExpansion]="true"
                secondaryText="" [showSaveCancel]="false" [hideExpandedHeader]="false"
                [alwaysHideExpandIcon]="cfg.form.sortedParams.length==0 || !cfg.checked">
                <div name>
                  <material-icon icon="drag_handle"></material-icon>
                  <div>{{cfg.form.display}}</div>
                </div>
                <formparams [paramList]="cfg.form.sortedParams"></formparams>
              </material-expansionpanel>
            </div>
          </div>
        </template>
      </div>
      <div class="tilelist" *ngIf="g.viewType=='tile' && tileParams==null">
        <template ngFor let-cfg let-idx="index" [ngForOf]="g.listConfig">
          <div [class]="tileClass(cfg)" id="tile-{{cfg.id}}"
               *ngIf="isFormVisible(cfg.form)"
               (click)="expansionPanelClicked($event,cfg)">
            <img *ngIf="g.tileShowImage" [src]="cfg.form.backimage">
            <div numberimg *ngIf="g.tileShowImage && cfg.checked">{{checkedIndex(cfg)}}</div>
            <div number *ngIf="!g.tileShowImage && cfg.checked">{{checkedIndex(cfg)}}</div>
            <div params *ngIf="cfg.form.sortedParams.length>0 && cfg.checked"
                 (click)="tileParams=cfg;$event.stopPropagation();">
              <material-icon icon="more_vert"></material-icon>
            </div>
            <div *ngIf="!g.tileShowImage" title>{{cfg.form.display}}</div>
            <div pages *ngIf="cfg.checked && (!g.tileShowImage || !cfg.form.isPortraitParam)">
              {{cfg.form.pageCountDisplay(reportData==null)}}
            </div>
            <div pagesportrait *ngIf="cfg.checked && g.tileShowImage && cfg.form.isPortraitParam">
              {{cfg.form.pageCountDisplay(reportData==null)}}
            </div>
          </div>
        </template>
      </div>
    </div>
    <div *ngIf="(currPage=='normal'||currPage=='pdfList')&&tileParams==null" [class]="classForView('sendPanel')">
      <material-fab *ngIf="sendIcon=='send'&&!sendDisabled"
                    [raised]="false"
                    [class]="sendClass(2,'shift2')"
                    [disabled]="sendDisabled"
                    (trigger)="shiftClick(g.listPeriodShift[2])">
        <div class="history">
          {{g.period.shiftStartBy(2).format(g.fmtDateForDisplay)}}
          <material-icon icon="history"></material-icon>
          {{g.period.shiftEndBy(2).format(g.fmtDateForDisplay)}}
        </div>
      </material-fab>
      <material-fab *ngIf="sendIcon=='send'&&!sendDisabled"
                    [raised]="false"
                    [class]="sendClass(1,'shift1')"
                    [disabled]="sendDisabled"
                    (trigger)="shiftClick(g.listPeriodShift[1])">
        <div class="history">
          {{g.period.shiftStartBy(1).format(g.fmtDateForDisplay)}}
          <material-icon icon="history"></material-icon>
          {{g.period.shiftEndBy(1).format(g.fmtDateForDisplay)}}
        </div>
      </material-fab>
      <material-fab [raised]="true"
                    [class]="sendClass(0,sendIcon)"
                    [disabled]="sendDisabled"
                    (trigger)="shiftClick(g.listPeriodShift[0])">
        <material-icon [icon]="createIcon"></material-icon>
      </material-fab>
    </div>
    <div class="themePanel" [style]="themeStyle" *ngIf="currPage=='normal'">
      <material-fab mini class="" *ngFor="let item of g.themeList.keys; let idx = index"
                    (trigger)="toggleThemePanel(item);">
        <img class="logo" src="packages/nightscout_reporter/assets/themes/wizard.png" *ngIf="item==null">
        <img class="logo" src="packages/nightscout_reporter/assets/themes/{{item}}/owl.png" *ngIf="item!=null">
      </material-fab>
    </div>
    <material-fab class="owllogo" (trigger)="toggleThemePanel('')" [style]="logoStyle">
      <img src="packages/nightscout_reporter/assets/themes/{{g.theme}}/owl.png">
    </material-fab>
  </material-content>
  <material-drawer scrollable persistent #drawer="drawer" [(visible)]="drawerVisible" [attr.overlay]="">
    <div class="drawer-root">
      <div class="menuControls">
        <material-button class="iconButton material-drawer-button" (trigger)="currPage='welcome';">
          <material-icon icon="home"></material-icon>
          <ng-container @i18n="title of welcome screen">Willkommen</ng-container>
        </material-button>
        <material-button class="iconButton material-drawer-button"
                         (trigger)="drawer.toggle();navigate('https://www.facebook.com/nightrep');">
          <svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" x="0px" y="0px"
               width="1.5em" height="1.5em" viewBox="0 0 266.893 266.895"
               enable-background="new 0 0 266.893 266.895"
               xml:space="preserve">
            <path id="Blue_1_" fill="#3C5A99"
                  d="M248.082,262.307c7.854,0,14.223-6.369,14.223-14.225V18.812	c0-7.857-6.368-14.224-14.223-14.224H18.812c-7.857,0-14.224,6.367-14.224,14.224v229.27c0,7.855,6.366,14.225,14.224,14.225 H248.082z"/>
            <path id="f" fill="#FFFFFF"
                  d="M182.409,262.307v-99.803h33.499l5.016-38.895h-38.515V98.777c0-11.261,3.127-18.935,19.275-18.935 l20.596-0.009V45.045c-3.562-0.474-15.788-1.533-30.012-1.533c-29.695,0-50.025,18.126-50.025,51.413v28.684h-33.585v38.895h33.585 v99.803H182.409z"/>
          </svg>
          <ng-container @i18n="title of facebook link">Facebook Seite</ng-container>
          <material-icon icon="open_in_new" size="medium"></material-icon>
        </material-button>
        <material-button class="iconButton material-drawer-button"
                         (trigger)="currPage='settings';drawer.toggle();">
          <material-icon icon="settings"></material-icon>
          <ng-container @i18n="title of settings">Einstellungen</ng-container>
        </material-button>
        <material-button class="iconButton material-drawer-button" (trigger)="drawer.toggle();changeView();">
          <material-icon *ngIf="g.viewType=='list'" icon="dashboard"></material-icon>
          <material-icon *ngIf="g.viewType=='tile'" icon="list"></material-icon>
          <ng-container @i18n="title of listview" *ngIf="g.viewType=='tile'">Zur Listenansicht</ng-container>
          <ng-container @i18n="title of tileview" *ngIf="g.viewType=='list'">Zur Kachelansicht</ng-container>
        </material-button>
        <signin [isVisible]="true" [autoStart]="g.loadStorage('syncGoogle')=='yes'" [showMenuButton]="true"
                [raised]="true" [(isAuthorized)]="g.syncGoogle"
                [clientId]="g.googleClientId"
                (trigger)="signinEvent($event)"
                (signinResult)="g.client=$event;"></signin>
        <material-button class="iconButton material-drawer-button" (trigger)="currPage='whatsnew';">
          <material-icon icon="new_releases"></material-icon>
          <ng-container @i18n="title of whatsnew screen">Was bisher geschah...</ng-container>
        </material-button>
      </div>
      <div class="menuLinks">
        <material-button *ngIf="g.user.apiUrl != null" class="iconButton material-drawer-button"
                         (trigger)="drawer.toggle();callNightscout();">
          <img src="packages/nightscout_reporter/assets/img/nightscout-white.png">
          <ng-container @i18n="title of nightscout page">Nightscout Seite</ng-container>
          <material-icon icon="open_in_new" size="medium"></material-icon>
        </material-button>
        <material-button *ngIf="g.user.reportUrl != null" class="iconButton material-drawer-button"
                         (trigger)="drawer.toggle();callNightscoutReports();">
          <img src="packages/nightscout_reporter/assets/img/nightscout-white.png">
          <ng-container @i18n="title of nightscout reports">Nightscout Berichte</ng-container>
          <material-icon icon="open_in_new" size="medium"></material-icon>
        </material-button>
        <div>
          <material-button *ngFor="let item of g.languageList"
                           (trigger)="g.changeLanguage(item)"
                           [class]="languageClass(item)">
            <img src="{{item.imgPath}}">
          </material-button>
        </div>
        <div>
          <material-button class="legal"
                           (trigger)="togglePage('impressum');">
            {{msgImpressum}}
          </material-button>
          <material-button class="legal"
                           (trigger)="togglePage('dsgvo');">
            {{msgDSGVO}}
          </material-button>
        </div>
        <div class="menuFabs" [style.display]="g.canDebug?'flex':'none'">
          <div *ngIf="isDebug" class="toggle-debug">
            <material-button icon mini class="material-drawer-button"
                             (trigger)="drawer.toggle();navigate('https://jsonformatter.org/json-parser');">
              <material-icon icon="code"></material-icon>
            </material-button>
            <material-button icon mini class="material-drawer-button"
                             (trigger)="drawer.toggle();navigate('https://translate.google.com/toolkit/');">
              <material-icon icon="g_translate"></material-icon>
            </material-button>
            <material-button icon mini class="material-drawer-button"
                             (trigger)="drawer.toggle();navigate('https://autotuneweb.azurewebsites.net/');">
              <material-icon icon="tune"></material-icon>
            </material-button>
          </div>
        </div>
      </div>
    </div>
  </material-drawer>
</div>
<div id="debugMessage" *ngIf="message.dbgText != null" (click)="message.clear();">
  <p [innerHTML]="message.dbgText"></p>
</div>
<div id="messagePanel" *ngIf="message.links.length > 0 || !message.isEmpty">
  <div id="message" *ngIf="!message.isEmpty || message.links.length > 0" [class]="message.type">
    <p [innerHTML]="message.text"></p>
    <material-button *ngFor="let entry of message.links" (trigger)="navigate(entry['url'])"
                     [class]="entry['class']">
      <material-icon *ngIf="entry['icon']!=null" [icon]="entry['icon']"></material-icon>
      {{entry['title']}}
    </material-button>
    <material-button icon class="msgClose" (trigger)="message.dismiss(message.clear)">
      <material-icon icon="close"></material-icon>
    </material-button>
  </div>
</div>
<form id="postForm" [target]="g.pdfTarget" method="post" action="{{pdfUrl}}">
  <input name="vfs" type="hidden" value="ja" *ngIf="g.language.code=='ja_JP'"/>
  <input name="filename" type="hidden" [value]="g.pdfDownload?pdfFilename(0):''"/>
  <input name="data" type="hidden" value="{{pdfData}}"/>{{pdfFilename(0)}}
</form>
